/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GroupMembershipRestriction type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupMembershipRestriction{}

// GroupMembershipRestriction struct for GroupMembershipRestriction
type GroupMembershipRestriction struct {
	SourceGroupId     *string `json:"sourceGroupId,omitempty"`
	RestrictedGroupId *string `json:"restrictedGroupId,omitempty"`
	Builtin           *bool   `json:"builtin,omitempty"`
}

// NewGroupMembershipRestriction instantiates a new GroupMembershipRestriction object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupMembershipRestriction() *GroupMembershipRestriction {
	this := GroupMembershipRestriction{}
	return &this
}

// NewGroupMembershipRestrictionWithDefaults instantiates a new GroupMembershipRestriction object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupMembershipRestrictionWithDefaults() *GroupMembershipRestriction {
	this := GroupMembershipRestriction{}
	return &this
}

// GetSourceGroupId returns the SourceGroupId field value if set, zero value otherwise.
func (o *GroupMembershipRestriction) GetSourceGroupId() string {
	if o == nil || IsNil(o.SourceGroupId) {
		var ret string
		return ret
	}
	return *o.SourceGroupId
}

// GetSourceGroupIdOk returns a tuple with the SourceGroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMembershipRestriction) GetSourceGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.SourceGroupId) {
		return nil, false
	}
	return o.SourceGroupId, true
}

// HasSourceGroupId returns a boolean if a field has been set.
func (o *GroupMembershipRestriction) HasSourceGroupId() bool {
	if o != nil && !IsNil(o.SourceGroupId) {
		return true
	}

	return false
}

// SetSourceGroupId gets a reference to the given string and assigns it to the SourceGroupId field.
func (o *GroupMembershipRestriction) SetSourceGroupId(v string) {
	o.SourceGroupId = &v
}

// GetRestrictedGroupId returns the RestrictedGroupId field value if set, zero value otherwise.
func (o *GroupMembershipRestriction) GetRestrictedGroupId() string {
	if o == nil || IsNil(o.RestrictedGroupId) {
		var ret string
		return ret
	}
	return *o.RestrictedGroupId
}

// GetRestrictedGroupIdOk returns a tuple with the RestrictedGroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMembershipRestriction) GetRestrictedGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.RestrictedGroupId) {
		return nil, false
	}
	return o.RestrictedGroupId, true
}

// HasRestrictedGroupId returns a boolean if a field has been set.
func (o *GroupMembershipRestriction) HasRestrictedGroupId() bool {
	if o != nil && !IsNil(o.RestrictedGroupId) {
		return true
	}

	return false
}

// SetRestrictedGroupId gets a reference to the given string and assigns it to the RestrictedGroupId field.
func (o *GroupMembershipRestriction) SetRestrictedGroupId(v string) {
	o.RestrictedGroupId = &v
}

// GetBuiltin returns the Builtin field value if set, zero value otherwise.
func (o *GroupMembershipRestriction) GetBuiltin() bool {
	if o == nil || IsNil(o.Builtin) {
		var ret bool
		return ret
	}
	return *o.Builtin
}

// GetBuiltinOk returns a tuple with the Builtin field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMembershipRestriction) GetBuiltinOk() (*bool, bool) {
	if o == nil || IsNil(o.Builtin) {
		return nil, false
	}
	return o.Builtin, true
}

// HasBuiltin returns a boolean if a field has been set.
func (o *GroupMembershipRestriction) HasBuiltin() bool {
	if o != nil && !IsNil(o.Builtin) {
		return true
	}

	return false
}

// SetBuiltin gets a reference to the given bool and assigns it to the Builtin field.
func (o *GroupMembershipRestriction) SetBuiltin(v bool) {
	o.Builtin = &v
}

func (o GroupMembershipRestriction) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupMembershipRestriction) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.SourceGroupId) {
		toSerialize["sourceGroupId"] = o.SourceGroupId
	}
	if !IsNil(o.RestrictedGroupId) {
		toSerialize["restrictedGroupId"] = o.RestrictedGroupId
	}
	if !IsNil(o.Builtin) {
		toSerialize["builtin"] = o.Builtin
	}
	return toSerialize, nil
}

type NullableGroupMembershipRestriction struct {
	value *GroupMembershipRestriction
	isSet bool
}

func (v NullableGroupMembershipRestriction) Get() *GroupMembershipRestriction {
	return v.value
}

func (v *NullableGroupMembershipRestriction) Set(val *GroupMembershipRestriction) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupMembershipRestriction) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupMembershipRestriction) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupMembershipRestriction(val *GroupMembershipRestriction) *NullableGroupMembershipRestriction {
	return &NullableGroupMembershipRestriction{value: val, isSet: true}
}

func (v NullableGroupMembershipRestriction) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupMembershipRestriction) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
